## lxd 2.0.8

=== debian/changelog ===
lxd (2.0.8-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 02 Dec 2016 12:03:36 -0500

lxd (2.0.8-0ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.8) (LP: #1644377)
    - Don't grab addresses from public remotes

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 24 Nov 2016 23:59:44 -0500

lxd (2.0.7-0ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.7) (LP: #1644377)
    - extra/bash: Better parse containers list
    - lxc/copy: Make container copy more robust
    - lxd/containers: Don't assign idmaps to privileged containers
    - lxd/containers: Don't break when parsing old containers
    - lxd/containers: Don't double apply templates
    - lxd/containers: Fix concurrent map iteration+modification
    - lxd/containers: Fix idmap handling of pre-idmap containers
    - tests: Add tests for file templating

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 24 Nov 2016 23:01:54 -0500

lxd (2.0.6-0ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.6) (LP: #1644377)
    - Support for container specific uid/gid maps (see userns-idmap.md)
    - appveyor: Add config to git
    - appveyor: Cleanup appveyor.yml before modifications
    - appveyor: Create archive with platform specifier in its name
    - appveyor: Do verbose testing for test names and timings
    - appveyor: Publish compiled binaries for download
    - client: Rework progress handling
    - doc: Add hacking guide (debugging.md)
    - doc: Add official Windows support in README
    - doc: Bump liblxc version required in README
    - doc: Sort API endpoints in rest-api.md
    - doc: Update README to specify docker installation details
    - doc: Update requirements, we actually require 2.0.0 or higher
    - doc: Use consistent method ordering in rest-api.md
    - extra/bash: Allow dash in parameters to lxc-client bash-completion
    - extra/bash: Fix _lxd_profiles in lxc-client bash-completion
    - extra/lxc-to-lxd: Better output with no container
    - extra/lxc-to-lxd: Check that source path exists (disk)
    - extra/lxc-to-lxd: Consistent logging
    - extra/lxc-to-lxd: Don't fail dry-run with running containers
    - extra/lxc-to-lxd: Drop dependency on pylxd
    - extra/lxc-to-lxd: Fix lxdpath handling
    - extra/lxc-to-lxd: Formatting
    - extra/lxc-to-lxd: Migrate lxc.aa_profile if set
    - extra/lxc-to-lxd: Print summary and proper exit code
    - lxc/copy: Don't use the operation as a marker of success
    - lxc/copy: Wait on the source operation too
    - lxc/delete: update help text
    - lxc/exec: Set term to "dumb" on windows
    - lxc/finger: update help text
    - lxc: Fix tests on Windows/Mac
    - lxc/list: Fix typo in help message
    - lxc/remote: Fix remote add with Go tip
    - lxc/restore: update help text
    - lxc: Use .yaml as the yaml extension in examples
    - lxd/certificates: Export all documented certificate fields
    - lxd/containers: Add /snap/bin to PATH even if only /snap exists
    - lxd/containers: Also clean up apparmor stuff on failure in OnStart
    - lxd/containers: Attach to userns on file operations
    - lxd/containers: Be more verbose on mkdir failure
    - lxd/containers: Better handle concurent stop/shutdown
    - lxd/containers: Catch and return more errors in OnStop
    - lxd/containers: Clarify container delete failure error
    - lxd/containers: Don't destroy ephemeral container on restart
    - lxd/containers: Don't double delete ephemeral containers
    - lxd/containers: Don't show invalid logs
    - lxd/containers: Fix forkmount to work with 4.8 and higher
    - lxd/containers: Fix invalid filename of metadata on export
    - lxd/containers: Improve config validation on update
    - lxd/containers: Improve container error handling
    - lxd/containers: Improve container locking mechanism
    - lxd/containers: log OnStart/OnStop hook errors
    - lxd/containers: More reliable container autostart
    - lxd/containers: Only load kernel modules if not loaded
    - lxd/containers: Properly validate CPU allowance
    - lxd/containers: Properly validate memory limits
    - lxd/containers: Record the err from go-lxc
    - lxd/containers: Remove legacy code from OnStop
    - lxd/containers: Remove unused code
    - lxd/containers: Save properties on publish
    - lxd/containers: Set LXC loglevel to match daemon
    - lxd/containers: Skip leading whitespace in raw.lxc
    - lxd/containers: Start storage when necessary in stateful start
    - lxd/containers: Timeout container freeze on stop
    - lxd/images: Detect out of disk space unpack errors
    - lxd/images: Don't make unnecessary image copies
    - lxd/images: Don't update images at all if interval is 0
    - lxd/images: Store the simplestreams cache to disk
    - lxd/init: Detect zfs kernel support
    - lxd/init: Ignore ZFS if in a container
    - lxd/main: Immediately exit when no DB in activateifneeded
    - lxd/migration: Fix a race for collecting logs
    - lxd/migration: Remove debugging by file creation
    - lxd/migration: Start migration storage at the right time
    - lxd/storage: Fix 10s delay on removing used ZFS images
    - lxd/storage: Freeze before copying in dir backend
    - lxd/storage: Simplify rsync code
    - shared/certificates: Be more thorough when parsing ip addr
    - shared: Disable keepalives in http.Transports
    - shared: Move Linux specific tests away
    - shared/simplestreams: Cleanup unused properties
    - tests: Better fix LXD_DEBUG
    - tests: Cleanup leftover containers
    - tests: Don't depend on main.sh for filemanip
    - tests: Implement LXD_VERBOSE


=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 3.9.7
Homepage: https://linuxcontainers.org/
Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 9),
               dh-apparmor,
               dh-golang,
               dh-systemd,
               golang-1.6-go,
               help2man,
               libsqlite3-dev,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               protobuf-compiler
XS-Testsuite: autopkgtest

Package: lxd-client
Architecture: amd64 arm64 armhf i386 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: lxd
Breaks: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Replaces: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: amd64 arm64 armhf i386 ppc64el
Pre-Depends: debconf
Depends: acl,
         adduser,
         dnsmasq-base,
         iptables,
         liblxc1 (>= 2.0.0~),
         lsb-base (>= 3.0-6),
         lxd-client (= ${binary:Version}),
         lxcfs,
         netcat-openbsd,
         rsync,
         squashfs-tools,
         uidmap,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: criu, lxd-tools
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

Package: lxc2
Architecture: all
Depends: lxd, lxd-client, ${misc:Depends}
Priority: extra
Section: metapackages
Description: Container hypervisor based on LXC - metapackage
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This is a dummy metapackage to install LXD and its client.

Package: lxd-tools
Architecture: amd64 arm64 armhf i386 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Container hypervisor based on LXC - extra tools
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids

Package: golang-github-lxc-lxd-dev
Architecture: all
Depends: golang-go, lxc-dev, pkg-config, ${misc:Depends}, ${shlibs:Depends}
Description: Container hypervisor based on LXC - go source
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the source tree of the lxd project.

## lxd 2.0.9

=== debian/changelog ===
lxd (2.0.9-0ubuntu1~14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 01 Mar 2017 00:46:46 -0500

lxd (2.0.9-0ubuntu1~16.04.2) xenial; urgency=medium

  * Cherry-pick upstream regression fix:
    - 0002-list-Fix-regression-in-json-output.patch (LP: #1667406)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 23 Feb 2017 12:56:02 -0500

lxd (2.0.9-0ubuntu1~16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.9) (LP: #1660506)
    - Exec sessions being killed by a signal will now report the signal
      number as part of their exit code.
    - VLAN device types are now properly reported in the API and client.
    - The client will now show the date an image was last used at.
    - The client will now let you delete multiple images at once.
    - LXD is now using Weblate for its translations.

    - client: Add a done signal to Monitor API
    - client: Better handle http errors
    - client: Commonize update methods
    - doc: Add Documentation on Network Configuration via cloud-init
    - doc: Added reference to godoc to README.md
    - doc: Update README.md for CI and Weblate status
    - extra/lxc-to-lxd: Add more unsupported config keys
    - extra/lxc-to-lxd: All properties must be strings
    - extra/lxc-to-lxd: Copy the rootfs by default, don't move it
    - extra/lxc-to-lxd: Show nicer error on missing python3-lxc
    - extra/lxc-to-lxd: Switch to using a config whitelist
    - global: Fix typos
    - global: "gofmt -s" run
    - lxc: Better handle timestamps
    - lxc: Make help messages more consistent
    - lxc: Properly check yaml errors
    - lxc/init: Fix example
    - lxc/init: Properly replace args list
    - lxc/launch: Just use init.go's flags()
    - lxc/list: Sort IPv4 and IPv6 addresses
    - lxc/remote: Update help
    - lxd-bridge: Add ip6tables filter rules
    - lxd-bridge: DHCP happens over UDP only
    - lxd-bridge: Make IPv4 firewalling optional (default is enabled)
    - lxd/containers: Add basic logging to container creation
    - lxd/containers: Allow passing in-memory buffers to a FileResponse
    - lxd/containers: Also call setgroups when attaching to the container
    - lxd/containers: Avoid race condition in network fill function
    - lxd/containers: Blacklist lxc.syslog and lxc.ephemeral in raw.lxc
    - lxd/containers: Detect background tasks to allow clean exit
    - lxd/containers: Do mounts in the right order
    - lxd/containers: Don't attempt to read xattrs from symlinks
    - lxd/containers: Don't block resolution on non-existing paths
    - lxd/containers: Don't record last_state.power twice
    - lxd/containers: Exec() return attached PID && take bool arg
    - lxd/containers: Fix container state recording
    - lxd/containers: Fix device hotplug with major/minor set
    - lxd/containers: Fix file push error handling
    - lxd/containers: Fix generated seccomp profile
    - lxd/containers: Fix logging for file_manip commands
    - lxd/containers: Improve error handling and reporting during export
    - lxd/containers: Return a clear error when replacing a directory
    - lxd/daemon: Common codepath for http client
    - lxd/daemon: Don't set InsecureSkipVerify on daemon's tls config
    - lxd/daemon: Log daemon version
    - lxd/daemon: Make directories with stricter permissions
    - lxd/daemon: Make LXD_DIR with +x for group and everyone
    - lxd/daemon: Only mark ready once containers are up
    - lxd/daemon: Properly validate daemon keys on unset
    - lxd/daemon: Use our custom http server when updating HTTPS address too
    - lxd/db: Drop unused code from db.go
    - lxd/images: Close race condition in image download
    - lxd/images: Track speed during network transfers
    - lxd/main: Move activateifneeded to own file
    - lxd/main: Move callhook to own file
    - lxd/main: Move daemon to own file
    - lxd/main: Move forkexec to own file
    - lxd/main: Move forkgetnet to own file
    - lxd/main: Move forkmigrate to own file
    - lxd/main: Move forkstart to own file
    - lxd/main: Move init to own file
    - lxd/main: Move migratedumpsuccess to own file
    - lxd/main: Move netcat to own file
    - lxd/main: Move ready to own file
    - lxd/main: Move shutdown to own file
    - lxd/main: Move waitready to own file
    - lxd/main: Rename nsexec.go to main_nsexec.go
    - lxd/migrate: Use the generated snapshot list
    - lxd/patches: Mark all patches as applied on create
    - lxd/profiles: Fix unusued variable
    - lxd/storage: btrfs: Don't assume a path is a subvolume
    - lxd/storage: Change ContainerStart to take the name and path to start
    - lxd/storage: Rework EEXISTS detection on create
    - lxd/storage: zfs: Simplify device tracking logic
    - Makefile: Rework "make dist" to be more reliable
    - shared: add GetPollRevents()
    - shared: Add WebsocketExecMirror()
    - shared: Centralize all cert fingerprint generation
    - shared: Convert TransferProgress to ReadCloser
    - shared: ExecReaderToChannel() use sync.Once
    - shared: Give Architecture handling its own package
    - shared: Give IO progress tracker its own package
    - shared: Give simplestreams client its own package
    - shared: Give version handling its own package
    - shared: Implement write tracking
    - shared: Make a helper to compute cert fingerprint
    - shared: Move Device/Devices types to lxd package
    - shared: Move FromLXCState out of shared
    - shared: Move REST API to new package: certificate
    - shared: Move REST API to new package: container
    - shared: Move REST API to new package: godoc
    - shared: Move REST API to new package: image
    - shared: Move REST API to new package: network


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://linuxcontainers.org/
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/flex.go | cut -d'"' -f2)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
export DH_GOPKG := github.com/lxc/lxd
export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
export USE_EMBEDDED := true

# use golang-1.6
export PATH := /usr/lib/go-1.6/bin:$(PATH)

%:
	dh $@ --with systemd --buildsystem=golang --with=golang

# Make sure we use the distro libsqlite3
override_dh_auto_build:
	dh_auto_build -- -tags libsqlite3

# Ugly workaround for bundled dependencies
override_dh_auto_configure:
	dh_auto_configure

	# dh-golang's configure has copied the source tree into GOPATH. But
	# because lxd gets some dependencies from the archive and some from
	# the copies bundled in dist, we have to unpick a bunch of what it has
	# done and set it up again.

	# Remove the extra copy of dist dh-golang has copied onto GOPATH (or
	# when dh-golang tries to run go install github.com/lxc/lxd/... things
	# get very confused).
	rm -Rf ${GOPATH}/src/github.com/lxc/lxd/dist

	# Move the lxd source aside while we do this.
	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp

	# Clean GOPATH.
	rm -Rf ${GOPATH}/src

ifeq ($(USE_EMBEDDED), true)
	# If we get all dependencies from dist, just copy it onto GOPATH.
	cp -R dist/src ${GOPATH}

	# But not the symlink for lxd.
	rm -f ${GOPATH}/src/github.com/lxc/lxd
else
	# If not, link depedencies from dist or from where the distro package
	# has installed it, as appropriate.

	# Packaged dependencies
	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
	debian/helpers/link-from-installed github.com/golang/protobuf
	debian/helpers/link-from-installed github.com/gorilla/context
	debian/helpers/link-from-installed github.com/gorilla/mux
	debian/helpers/link-from-installed github.com/gorilla/websocket
	debian/helpers/link-from-installed github.com/gosexy/gettext
	debian/helpers/link-from-installed github.com/mattn/go-colorable
	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
	debian/helpers/link-from-installed github.com/pborman/uuid
	debian/helpers/link-from-installed github.com/syndtr/gocapability
	debian/helpers/link-from-installed golang.org/x/crypto
	debian/helpers/link-from-installed gopkg.in/flosch/pongo2.v3
	debian/helpers/link-from-installed gopkg.in/inconshreveable/log15.v2
	debian/helpers/link-from-installed gopkg.in/lxc/go-lxc.v2
	debian/helpers/link-from-installed gopkg.in/tomb.v2
	debian/helpers/link-from-installed gopkg.in/yaml.v2
endif

	# And put the lxd source back again.
	mkdir -p ${GOPATH}/src/github.com/lxc/
	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd

override_dh_install:
	# Install the manpages
	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1

	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc

	# Prepare dev package
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist

	# Apparmor
	dh_apparmor -p lxd --profile-name=usr.lib.lxd.lxd-bridge-proxy

	# Setup logrotate
	mkdir -p $(PKGDIR)/etc/logrotate.d
	cp debian/lxd.logrotate $(PKGDIR)/etc/logrotate.d/lxd

	# Trigger normal dh_install
	dh_install

override_dh_installinit:
	# We handle starting and restarting things ourselves
	dh_systemd_enable -plxd --name=lxd-bridge lxd-bridge.service
	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
	dh_installinit -plxd --no-start
	dh_installinit -plxd --name=lxd-bridge --no-start --noscripts
	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade

	# Update arch-specific paths
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init/lxd.conf
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init.d/lxd

override_dh_systemd_start:
	echo "Not running dh_systemd_start"

override_dh_auto_test:
	echo "The testsuite requires privileges and so is run through autopkgtest"

## lxd 2.0.10

=== debian/changelog ===
lxd (2.0.10-0ubuntu1~14.04.2) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 30 Aug 2017 12:48:03 -0400

lxd (2.0.10-0ubuntu1~16.04.2) xenial; urgency=medium

  * Fix regression in image update logic (LP: #1712455):
    - 0005-Fix-regression-in-image-auto-update-logic.patch
    - 0006-lxd-images-Carry-old-cached-value-on-refresh.patch
    - 0007-Attempt-to-restore-the-auto_update-property.patch

  * Ship a sysctl.d file that bumps inotify watches count. (LP: #1602192)
  * Update debian/watch to look only at LTS releases.

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 22 Aug 2017 20:39:36 -0400

lxd (2.0.10-0ubuntu1~16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.10) (LP: #1693340)
    - client: Backported the new client library and ported some of the
      internal commands over to it
    - lxc: Add a manpage command
    - lxc: Allow --version to be passed with any command
    - lxc: Reworked all help messages in the client to work with help2man
    - lxd: AppArmor namespacing is now also enabled for privileged containers

    - build: Add debug logging
    - client: Fix profile list
    - client: Remove unneeded condition
    - doc: Add instructions to grow ZFS loop
    - doc: Add note about escaping btrfs qgroups
    - doc: Add note about restricting access to kernel ring buffer
    - doc: Extract containers documentation to containers.md
    - doc: Extract profiles documentation to profiles.md
    - doc: Extract server documentation to server.md
    - doc: Fix badly named example device
    - doc: Fix broken table
    - doc: Note that LXD assumes full control over the pool
    - doc: Update configuration.md with links to other documents
    - doc: Update README.md for new API client
    - extra/lxc-to-lxd: Don't crash on missing mount file
    - extra/lxc-to-lxd: Typo in description of --move-rootfs
    - extra/vagrant: Trailing whitespace
    - global: Fix error handling in all filepath.Walk calls
    - global: Fix a number of typos
    - global: Forward user-agent and other headers on redirect
    - global: Replace file Chmod() with os.Chmod()
    - global: Use containerGetParentAndSnapshotName()
    - global: Use RunCommand everywhere
    - lxc: Don't include spaces in translated strings
    - lxc: Improve batch mode
    - lxc: Make help/usage a bit more consistent
    - lxc: Move common functions/types to utils.go
    - lxc: Properly clear transfer stats on error
    - lxc: Rework for better manpages
    - lxc/config: Add new config handling code
    - lxc/config: Always use "simplestreams" for images:
    - lxc/config: Fix path handling
    - lxc/config: Fix SaveConfig's DeepCopy call
    - lxc/copy: Improve error handling
    - lxc/copy: Return the source error too
    - lxc/copy: Simplify
    - lxc/copy: Wait asynchronously
    - lxc/image: Show the alias description
    - lxc/image: Trailing whitespace
    - lxc/init: Drop unnecessary else statement
    - lxc/list: Document list format options
    - lxc/list: Fix regression in json output
    - lxc/list: Move common data extraction to a helper function
    - lxc/profile: Properly implement "profile unset"
    - lxc/publish: Wait for the container to be running
    - lxc/remote: Show the fingerprint as string not hex
    - lxc/utils: Implement progress tracking for operations
    - lxd: Drop use of logger.Log when not needed
    - lxd/apparmor: Fix AppArmor stack handling with nesting
    - lxd/containers: Add containerGetParentAndSnapshotName()
    - lxd/containers: Added soft limit in initLXD()
    - lxd/containers: Added soft memory limit even when hard is selected
    - lxd/containers: Add extra validation for unix-block/unix-char
    - lxd/containers: Add function to detect root disk device
    - lxd/containers: Allow for stable host interface names
    - lxd/containers: Clarify uid/gid error
    - lxd/containers: Cleanup root device validation
    - lxd/containers: Disable IPv6 on host side veth when bridged
    - lxd/containers: Don't ignore snapshot deletion failures
    - lxd/containers: Don't parse id ranges as int32
    - lxd/containers: Don't report migration success on failure
    - lxd/containers: Don't use FindProcess, just pass exec.Cmd
    - lxd/containers: Find current max snapshot value
    - lxd/containers: Fix bad root device detection code
    - lxd/containers: Fix base image tracking
    - lxd/containers: Fix concurrent read/write to s.conns in exec
    - lxd/containers: Fix error handling on FileRemove
    - lxd/containers: Fix handling of devices with minor>255
    - lxd/containers: Fix override of Devices during copy
    - lxd/containers: Fix soft limit logic to use float64
    - lxd/containers: Initialize idmap on demand
    - lxd/containers: Kill forkexec on abnormal websocket closure
    - lxd/containers: Path may only be used by one disk
    - lxd/containers: Properly invalidate the idmap cache
    - lxd/containers: Properly revert memory limits on failure
    - lxd/containers: Properly validate architectures
    - lxd/containers: Set default values for USER, HOME and LANG
    - lxd/containers: This condition has already been deal
    - lxd/containers: Use int64 for uid and gid everywhere
    - lxd/containers: Validate container idmap as early as possible
    - lxd/containers: Validate expanded configuration after root setup
    - lxd/containers: Validate the expanded config at container create
    - lxd/daemon: Check for the validity of the id maps at startup
    - lxd/daemon: Fix some race conditions
    - lxd/daemon: Mount a tmpfs under devlxd
    - lxd/daemon: s/Default map/Available map/
    - lxd/daemon: Set ServerFingerprint
    - lxd/daemon: Use a tmpfs for shmounts


=== debian/rules ===
--- 
+++ 
@@ -100,6 +100,10 @@
 	mkdir -p $(PKGDIR)/etc/logrotate.d
 	cp debian/lxd.logrotate $(PKGDIR)/etc/logrotate.d/lxd
 
+	# Setup sysctl
+	mkdir -p $(PKGDIR)/etc/sysctl.d
+	cp debian/lxd.sysctl $(PKGDIR)/etc/sysctl.d/10-lxd-inotify.conf
+
 	# Trigger normal dh_install
 	dh_install

## lxd 2.0.11

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar
TAGS=$(shell test -e /usr/include/sqlite3.h && echo "-tags libsqlite3")

.PHONY: default
default:
	go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: update
update:
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

.PHONY: update
update-schema:
	go run -v $(TAGS) ./lxd/schema.go
	@echo "Schema source code updated"

.PHONY: debug
debug:
	go get -t -v -d ./...
	go install -v $(TAGS) -tags logdebug $(DEBUG) ./...
	@echo "LXD built successfully"

# This only needs to be done when migrate.proto is actually changed; since we
# commit the .pb.go in the tree and it's not expected to change very often,
# it's not a default build step.
.PHONY: protobuf
protobuf:
	protoc --go_out=. ./lxd/migrate.proto

.PHONY: check
check: default
	go get -v -x github.com/rogpeppe/godeps
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go get -v -x github.com/golang/lint/golint
	go test -v $(TAGS) $(DEBUG) ./...
	cd test && ./main.sh

gccgo:
	go build -v $(TAGS) $(DEBUG) -compiler gccgo ./...
	@echo "LXD built successfully with gccgo"

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/dist/src/github.com/lxc
	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd

	# Download dependencies
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...

	# Workaround for gorilla/mux on Go < 1.7
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -v -d github.com/gorilla/context

	# Assemble tarball
	rm $(TMP)/dist/src/github.com/lxc/lxd
	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot update-po

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go

build-mo: $(MOFILES)

static-analysis:
	(cd test;  /bin/sh -x -c ". suites/static_analysis.sh; test_static_analysis")

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== dist/src/gopkg.in/lxc/go-lxc.v2/Makefile ===
NO_COLOR=\033[0m
OK_COLOR=\033[0;32m

all: format vet lint

format:
	@echo "$(OK_COLOR)==> Formatting the code $(NO_COLOR)"
	@gofmt -s -w *.go
	@goimports -w *.go || true

test:
	@echo "$(OK_COLOR)==> Running go test $(NO_COLOR)"
	@sudo `which go` test -v

test-race:
	@echo "$(OK_COLOR)==> Running go test $(NO_COLOR)"
	@sudo `which go` test -race -v

test-unprivileged:
	@echo "$(OK_COLOR)==> Running go test for unprivileged user$(NO_COLOR)"
	@`which go` test -v

test-unprivileged-race:
	@echo "$(OK_COLOR)==> Running go test for unprivileged user$(NO_COLOR)"
	@`which go` test -race -v

cover:
	@sudo `which go` test -v -coverprofile=coverage.out
	@`which go` tool cover -func=coverage.out

doc:
	@`which godoc` gopkg.in/lxc/go-lxc.v2 | less

vet:
	@echo "$(OK_COLOR)==> Running go vet $(NO_COLOR)"
	@`which go` vet .

lint:
	@echo "$(OK_COLOR)==> Running golint $(NO_COLOR)"
	@`which golint` . || true

escape-analysis:
	@go build -gcflags -m

ctags:
	@ctags -R --languages=c,go

setup-test-cgroup:
	for d in /sys/fs/cgroup/*; do \
	    [ -f $$d/cgroup.clone_children ] && echo 1 | sudo tee $$d/cgroup.clone_children; \
	    [ -f $$d/cgroup.use_hierarchy ] && echo 1 | sudo tee $$d/cgroup.use_hierarchy; \
	    sudo mkdir -p $$d/lxc; \
	    sudo chown -R $$USER: $$d/lxc; \
	done

.PHONY: all format test doc vet lint ctags

=== debian/changelog ===
lxd (2.0.11-0ubuntu1~16.04.4) xenial; urgency=medium

  * Fix another regression in "lxd init":
    - When using the "dir" backend a unrelated profile warning was shown

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 07 Dec 2017 16:31:09 -0500

lxd (2.0.11-0ubuntu1~16.04.3) xenial; urgency=medium

  * Fix two regressions in "lxd init" (LP: #1737020):
    - Missing question for ZFS pool name (when creating new one)
    - Missing LXD bridge questions

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 07 Dec 2017 14:02:54 -0500

lxd (2.0.11-0ubuntu1~16.04.2) xenial; urgency=medium

  * Cherry-pick upstream fixes:
    - 0010-zfs-Fix-slowdown-because-of-mountpoint-check.patch
    - 0011-tests-Deal-with-missing-ttyS0-ttyS1-on-s390x.patch

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 23 Nov 2017 15:29:57 -0500

lxd (2.0.11-0ubuntu1~16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.11) (LP: #1731146)
    - It's now possible to interrupt image downloads
    - Added a new security.idmap.base config key
      (overrides the base uid/gid of the container)
    - Added support for delta image downloads
    - Implemented instance types as a proxy for resource limits
    - The user-agent string was expanded to include OS and kernel information
    - The client library and related code is now kept in sync with master
    - The command line client has been ported to the new client library

    - client: Add CancelTarget to RemoteOperation
    - client: Add CreateContainerFromImage function
    - client: Added insecureSkipVerify flag the ConnectionArgs struct
    - client: Add extra exec option to block on I/O
    - client: Add GetServerResources()
    - client: Add GetStoragePoolResources()
    - client: Add image_create_aliases backward compat
    - client: Add RenameStoragePoolVolume()
    - client: Allow canceling image download from LXDs
    - client: Allow specifying base http client
    - client: Cleanup code duplication in image download code
    - client: Commonize error handling
    - client: Don't live migrate stopped containers
    - client: Drop experimental tag from new client
    - client: Fail if source isn't listening on network
    - client: Fix crash in operation handler
    - client: Fix crash when missing cookiejar
    - client: Fix handling of public LXD remote
    - client: Fix image copy
    - client: Fix non-interactive exec hangs
    - client: Fix potential race in event handler setup
    - client: Fix race condition in operation handling
    - client: Implement container and snapshot copy
    - client: Implement push and relay container copy
    - client: Implement remote operations
    - client: Improve error on image copy
    - client: Improve migration relay code
    - client: Keep track of protocol
    - client: Make it possible to retrieve HTTP client
    - client: Make the authentication Interactor configurable
    - client: Move CopyImage to the target server
    - client: Only set file headers if value is provided
    - client: Properly handle remote disconnections
    - client: Reduce request logging to Debug
    - client: Simplify ConnectPublicLXD logic
    - client: Support for macaroons-based authentication
    - client: Sync with master branch
    - client: Use RemoteOperation for CopyImage
    - config: Add support for CookieJar
    - config: Try to be clever about ":" in snapshots
    - doc: Add a note about blkio limits
    - doc: Add section on macvlan vs bridge
    - doc: Add SUPPORT.md
    - doc: Document instance types
    - doc: Document that squashfs images can also be used
    - doc: Document the exec control API
    - doc: Extend/rework security-related documentation.
    - doc: Fix lxd.log location in issue template
    - doc: Fix spaces, commas, quotes, brackets where needed
    - doc: Initial documentation of container env
    - doc: Refresh the issue template
    - doc: Seriously rework the content of the README
    - doc: Sort container config keys
    - doc: Sort server.md config keys
    - doc: Update containers.md
    - extra/lxc-to-lxd: Fix bad test
    - extra/lxc-to-lxd: Ignore capabilities dropped by default
    - extra/lxc-to-lxd: Ignore sysfs/proc mounts
    - extra/lxc-to-lxd: Properly handle lxc.seccomp
    - i18n: Update Japanese translation (for stable-2.0)
    - lxc: Add plumbing for operation cancelation
    - lxc: Cross-platform HOME handling
    - lxc: Fix help to provide sample that actually works
    - lxc: Fix import crash when adding properties
    - lxc: Fix race in progress reporter
    - lxc: Properly record alias source on copy
    - lxc: Re-introduce remote protocol migration
    - lxc: Respect HOME if set
    - lxc/config: Removal of multiple devices at once
    - lxc/copy: Report progress data
    - lxc/delete: Fix lxc delete --force description
    - lxc/exec: Fix signal handler for Windows
    - lxc/exec: Fix Windows port
    - lxc/file: Fix file push/pull with names containing spaces.
    - lxc/file: Read file perms from Windows FS
    - lxc/file: Use shared.HostPath for push/pull
    - lxc/image: Always use long fingerprint in exported filenames
    - lxc/image: Expose the "cached" flag
    - lxc/image: Fix aliases with simplestreams remotes
    - lxc/image: Fix "lxc image copy" not recording the source
    - lxc/image: Fix regression in exported filename
    - lxc/image: Improve filter handling
    - lxc/image: Make "lxc image copy" fast again
    - lxc/image: Update image aliases when they already exist
    - lxc/image: Use shared.HostPath for import/export
    - lxc/init: Fix failure to launch containers with random names
    - lxc/list: Error if --columns and --fast are used together
    - lxc/move: Use force on delete
    - lxc/publish: Fix fingerprint printing
    - lxc/remote: Don't require a cert for public remotes
    - lxc/utils: Avoid potential progress race condition
    - lxc/utils: Println doesn't do format strings
    - lxd-benchmark: Add CreateContainers function


=== debian/control ===
--- 
+++ 
@@ -10,8 +10,26 @@
                dh-apparmor,
                dh-golang,
                dh-systemd,
-               golang-1.6-go,
+               golang-go,
+               golang-go.crypto-dev,
+               golang-context-dev,
+               golang-github-gorilla-mux-dev,
+               golang-github-gosexy-gettext-dev,
+               golang-github-mattn-go-colorable-dev,
+               golang-github-mattn-go-sqlite3-dev,
+               golang-github-olekukonko-tablewriter-dev,
+               golang-github-pborman-uuid-dev,
+               golang-gocapability-dev,
+               golang-gopkg-flosch-pongo2.v3-dev,
+               golang-gopkg-inconshreveable-log15.v2-dev,
+               golang-gopkg-lxc-go-lxc.v2-dev,
+               golang-gopkg-tomb.v2-dev,
+               golang-goprotobuf-dev,
+               golang-petname-dev,
+               golang-yaml.v2-dev,
+               golang-websocket-dev,
                help2man,
+               libacl1-dev,
                libsqlite3-dev,
                lxc-dev (>= 1.1.0~),
                pkg-config,
@@ -19,7 +37,7 @@
 XS-Testsuite: autopkgtest
 
 Package: lxd-client
-Architecture: amd64 arm64 armhf i386 ppc64el
+Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Suggests: lxd
@@ -32,7 +50,7 @@
  This package contains the command line client.
 
 Package: lxd
-Architecture: amd64 arm64 armhf i386 ppc64el
+Architecture: any
 Pre-Depends: debconf
 Depends: acl,
          adduser,
@@ -69,7 +87,7 @@
  This is a dummy metapackage to install LXD and its client.
 
 Package: lxd-tools
-Architecture: amd64 arm64 armhf i386 ppc64el
+Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Description: Container hypervisor based on LXC - extra tools

=== debian/rules ===
--- 
+++ 
@@ -11,10 +11,7 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := true
-
-# use golang-1.6
-export PATH := /usr/lib/go-1.6/bin:$(PATH)
+export USE_EMBEDDED := false
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
@@ -80,9 +77,9 @@
 override_dh_install:
 	# Install the manpages
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
-	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
-	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
-	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
+	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/fuidshift.1
+	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxc.1
+	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd.1
 
 	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
 	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://linuxcontainers.org/lxd/downloads/lts/ /downloads/lxd/lxd-(.*)\.tar\.gz

## lxd 2.4.1

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
                dh-golang,
                dh-systemd,
                golang-go,
+               golang-any-shared-dev,
                golang-go.crypto-dev,
                golang-context-dev,
                golang-github-gorilla-mux-dev,
@@ -29,12 +30,9 @@
                golang-yaml.v2-dev,
                golang-websocket-dev,
                help2man,
-               libacl1-dev,
-               libsqlite3-dev,
                lxc-dev (>= 1.1.0~),
                pkg-config,
                protobuf-compiler
-XS-Testsuite: autopkgtest
 
 Package: lxd-client
 Architecture: any
@@ -51,16 +49,14 @@
 
 Package: lxd
 Architecture: any
-Pre-Depends: debconf
 Depends: acl,
          adduser,
          dnsmasq-base,
+         ebtables,
          iptables,
          liblxc1 (>= 2.0.0~),
-         lsb-base (>= 3.0-6),
          lxd-client (= ${binary:Version}),
          lxcfs,
-         netcat-openbsd,
          rsync,
          squashfs-tools,
          uidmap,

=== debian/rules ===
--- 
+++ 
@@ -12,13 +12,14 @@
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
 export USE_EMBEDDED := false
+export USE_SHLIBS := true
+
+ifeq ($(USE_SHLIBS), true)
+export DH_GOLANG_LINK_SHARED := 1
+endif
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
-
-# Make sure we use the distro libsqlite3
-override_dh_auto_build:
-	dh_auto_build -- -tags libsqlite3
 
 # Ugly workaround for bundled dependencies
 override_dh_auto_configure:
@@ -38,7 +39,11 @@
 	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp
 
 	# Clean GOPATH.
+ifeq ($(USE_SHLIBS), true)
+	rm -Rf ${GOPATH}/src/srclibs
+else
 	rm -Rf ${GOPATH}/src
+endif
 
 ifeq ($(USE_EMBEDDED), true)
 	# If we get all dependencies from dist, just copy it onto GOPATH.
@@ -77,9 +82,9 @@
 override_dh_install:
 	# Install the manpages
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
-	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/fuidshift.1
-	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxc.1
-	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd.1
+	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
+	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
+	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
 
 	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
 	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc
@@ -90,26 +95,17 @@
 	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
 	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist
 
-	# Apparmor
-	dh_apparmor -p lxd --profile-name=usr.lib.lxd.lxd-bridge-proxy
-
-	# Setup logrotate
-	mkdir -p $(PKGDIR)/etc/logrotate.d
-	cp debian/lxd.logrotate $(PKGDIR)/etc/logrotate.d/lxd
-
-	# Setup sysctl
-	mkdir -p $(PKGDIR)/etc/sysctl.d
-	cp debian/lxd.sysctl $(PKGDIR)/etc/sysctl.d/10-lxd-inotify.conf
+	# copy dnsmasq configuration
+	mkdir -p $(PKGDIR)/etc/dnsmasq.d-available
+	cp debian/lxd.dnsmasq $(PKGDIR)/etc/dnsmasq.d-available/lxd
 
 	# Trigger normal dh_install
 	dh_install
 
 override_dh_installinit:
 	# We handle starting and restarting things ourselves
-	dh_systemd_enable -plxd --name=lxd-bridge lxd-bridge.service
 	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
 	dh_installinit -plxd --no-start
-	dh_installinit -plxd --name=lxd-bridge --no-start --noscripts
 	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
 	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade

## lxd 2.7

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar

.PHONY: default
default:
	# Must a few times due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	# Must a few times due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: update
update:
	# Must a few times due to go get race
	-go get -t -v -d -u ./...
	-go get -t -v -d -u ./...
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

# This only needs to be done when migrate.proto is actually changed; since we
# commit the .pb.go in the tree and it's not expected to change very often,
# it's not a default build step.
.PHONY: protobuf
protobuf:
	protoc --go_out=. ./lxd/migrate.proto

.PHONY: check
check: default
	go get -v -x github.com/rogpeppe/godeps
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go test -v ./...
	cd test && ./main.sh

gccgo:
	go build -compiler gccgo ./...
	@echo "LXD built successfully with gccgo"

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz
	
	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/dist/src/github.com/lxc
	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd
	
	# Download dependencies
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	
	# Assemble tarball
	rm $(TMP)/dist/src/github.com/lxc/lxd
	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/
	
	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	-for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go


build-mo: $(MOFILES)

static-analysis:
	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags
